<?php
	namespace sv_media_library;
	
	class freemius extends init {
		public function __construct() {
		
		}
		
		public function init() {
			if ( $this->is_parent_active_and_loaded() ) {
				// Init Freemius.
				$this->load_sdk();

				// Signal that the add-on's SDK was initiated.
				do_action( 'sv_media_library_freemius_loaded' );

				// Parent is active, add your init code here.
			} else if ( $this->is_parent_active() ) {
				// Init add-on only after the parent is loaded.
				add_action( 'sv100_companion_freemius_loaded', array($this, 'init') );
			} else {
				// Even though the parent is not activated, execute add-on for activation / uninstall hooks.
				$this->load_sdk();
			}
		}
		public function load_sdk() {
			global $sv_media_library_freemius;

			$sv_media_library_freemius = fs_dynamic_init( array(
				'id'                  => '4137',
				'slug'                => 'sv-media-library',
				'premium_slug'        => 'sv_icon-premium',
				'type'                => 'plugin',
				'public_key'          => 'pk_90c43f3a53c4b4e7f7a00151c0bc0',
				'is_premium'          => false,
				'has_paid_plans'      => false,
				'parent'              => array(
					'id'         => '4082',
					'slug'       => 'sv100-companion',
					'public_key' => 'pk_bb203616096bc726f69ca51a0bbe3',
					'name'       => 'SV100 Companion',
				),
				'menu'                => array(
					'slug'           => 'sv_media_library',
					'support'        => false,
					'parent'         => array(
						'slug' => 'straightvisions',
					),
				),
			) );

			return $sv_media_library_freemius;
		}
		function is_parent_active_and_loaded() {
			// Check if the parent's init SDK method exists.
			return $this->is_instance_active('sv100_companion');
		}

		function is_parent_active() {
			$active_plugins = get_option( 'active_plugins', array() );

			if ( is_multisite() ) {
				$network_active_plugins = get_site_option( 'active_sitewide_plugins', array() );
				$active_plugins         = array_merge( $active_plugins, array_keys( $network_active_plugins ) );
			}

			foreach ( $active_plugins as $basename ) {
				if ( 0 === strpos( $basename, 'sv100-companion/' ) ||
					0 === strpos( $basename, 'sv100-companion-premium/' )
				) {
					return true;
				}
			}

			return false;
		}
	}